<?php
/*
Plugin Name: TweetThis
Version: auto
Description: Add a "Tweet This" button on picture pages
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=560
Author: Mistic
Author URI: http://www.strangeplanet.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('TWEET_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

load_language('plugin.lang', TWEET_PATH);
add_event_handler('loc_end_picture', 'tweet_add_button');
add_event_handler('loc_end_index', 'tweet_add_button');


function tweet_add_button() 
{
  global $conf, $template, $user;
  
  $conf['TweetThis'] = unserialize($conf['TweetThis']);
  $conf['TweetThis']['lang'] = array(
    'no','de','zh-cn','en','pl','sv','zh-tw','tr','es','th','fa','hu','pt','it','ar','he',
    'ko','id','ru','ja','da','fi','hi','ur','fr','nl',
    );
  
  $template->assign(array(
    'TWEET_SIZE' => $conf['TweetThis']['size'],
    'TWEET_COUNT' => $conf['TweetThis']['count'],
    'TWEET_VIA' => $conf['TweetThis']['via'],
  ));
  
  if (script_basename() == 'picture')
  {
    $template->assign('TWEET_POSITON', $conf['TweetThis']['position']);
    $template->set_prefilter('picture', 'tweet_add_button_prefilter');
  }
  else if (script_basename() == 'index')
  {
    $template->assign('TWEET_POSITON', 'index');
    $template->set_prefilter('index', 'tweet_add_button_prefilter');
  }
  
  // button language
  if ( in_array(str_replace('_','-',strtolower($user['language'])), $conf['TweetThis']['lang']) )
  {
    $template->assign('TWEET_LANG', str_replace('_','-',strtolower($user['language'])));
  }
  if ( in_array(substr($user['language'],0,2), $conf['TweetThis']['lang']) )
  {
    $template->assign('TWEET_LANG', substr($user['language'],0,2));
  }
  else
  {
    $template->assign('TWEET_LANG', 'en');
  }
}

function tweet_add_button_prefilter($content, &$smarty)
{
  global $template;
  
  $replace = '{combine_script id=\'twitter_widgets\' path=\'http://platform.twitter.com/widgets.js}
  <a href="https://twitter.com/share" class="twitter-share-button" data-lang="{$TWEET_LANG}" {if not empty($TWEET_VIA)}data-via="{$TWEET_VIA}"{/if} {if $TWEET_SIZE=="large"}data-size="large"{/if} {if not $TWEET_COUNT}data-count="none"{/if}>Tweet</a>';
  
  switch ($template->get_template_vars('TWEET_POSITON'))
  {
    case 'top':
      $search = '<div id="theImage">';
      $replace = '<div>'.$replace.'</div>';
      break;
      
    case 'bottom':
      $search = '{$ELEMENT_CONTENT}';
      break;
      
    case 'toolbar':
      $search = '<div class="actionButtons">';
      break;
      
    case 'index':  
      $search = '<ul class="categoryActions">';
      $replace = '<li>'.$replace.'</li>';
      break;
  }
  
  return str_replace($search, $search.$replace, $content);
}


if (script_basename() == 'admin')
{
  add_event_handler('get_admin_plugin_menu_links', 'tweet_plugin_admin_menu');

  function tweet_plugin_admin_menu($menu)
  {
    array_push($menu, array(
      'NAME' => 'TweetThis',
      'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
      ));
    return $menu;
  }
}

?>